/******************************************************************************
*-----------------------------------------------------------------------------
*  dma_init.c
*@DMȀݒt@C
*  DMA0 SPI̎MpɁADMA1SPȊMpɗp
*@SPȊMSPĨANZXn߂邽߂ɗpĂ邾
*@f[^̂̂̓_~[̂̂𑗏o
******************************************************************************/
#include "c55x_regs.h"
#include "DSP_ADC.h"

extern unsigned long gBufADC[2][DMA_BUF_SIZE];
extern unsigned int gPointerBufADC;
#pragma DATA_SECTION(DummySpiXmtData,"DARAM_any");
unsigned long DummySpiXmtData=0x10000000;

interrupt void dma0int(void);

void dma_init(void)
{
	/*DMA0 SPI̎Mf[^pɏ*/
	/*DMA0 McBSP0_recv to DARAM*/
	DMACSDP0 = 0x020e;
			// 0000 0010 0000 1110b
			// 00~~ ~~~~ ~~~~ ~~~~	(DSTBEN)
			// ~~0~ ~~~~ ~~~~ ~~~~	(DSTPACK)
			// ~~~0 001~ ~~~~ ~~~~	(DST)=>DARAM
			// ~~~~ ~~~0 0~~~ ~~~~	(SRCBEN)
			// ~~~~ ~~~~ ~0~~ ~~~~	(SRCPACK)
			// ~~~~ ~~~~ ~~00 11~~	(SRC)=>peripheral
			// ~~~~ ~~~~ ~~~~ ~~10	(DATATYPE)32bit
	
	//AutoinitARepeatƂ邱Ƃɂ莩Iɓ]p
	DMACCR0= 0x4305;
			// 0100 0011 0000 0101b
			// 01~~ ~~~~ ~~~~ ~~~~	(DSTAMODE)auto inc
			// ~~00 ~~~~ ~~~~ ~~~~	(SRCAMODE)constant
			// ~~~~ 0~~~ ~~~~ ~~~~	(ENDPROG)
			// ~~~~ ~0~~ ~~~~ ~~~~	(WP)
			// ~~~~ ~~1~ ~~~~ ~~~~	(REPEAT)
			// ~~~~ ~~~1 ~~~~ ~~~~	(AUTOINIT)
			// ~~~~ ~~~~ 0~~~ ~~~~	(EN)
			// ~~~~ ~~~~ ~0~~ ~~~~	(PRIO)
			// ~~~~ ~~~~ ~~0~ ~~~~	(FS)
			// ~~~~ ~~~~ ~~~0 0101	(SYNC)mcbsp1 recv event
	
	//荞ݗv̎w
	DMACICR0= 0x000c;
			// 0000 0000 0000 1100b
			// ~~~~ ~~~0 ~~~~ ~~~~	Reserved (always write 0)
			// ~~~~ ~~~~ 0~~~ ~~~~	(AERRIE)
			// ~~~~ ~~~~ ~~0~ ~~~~	(BLOCKIE)
			// ~~~~ ~~~~ ~~~0 ~~~~	(LASTIE)
			// ~~~~ ~~~~ ~~~~ 1~~~	(FRAMEIE)
			// ~~~~ ~~~~ ~~~~ ~1~~	(HALFIE)
			// ~~~~ ~~~~ ~~~~ ~~0~	(DROPIE)
			// ~~~~ ~~~~ ~~~~ ~~~0	(TIMEOUTIE)

	//DMA̓]E]̎wioCgAhXŎw肷邱Ɓj
    DMACSSA0U = (unsigned short)(((unsigned long)(DRR21_ADDR)) >> 15) & 0xFFFFu;
    DMACSSA0L = (unsigned short)(((unsigned long)(DRR21_ADDR)) << 1) & 0xFFFFu;
    DMACDSA0U = (unsigned short)(((unsigned long)(&gBufADC)) >> 15) & 0xFFFFu;
    DMACDSA0L = (unsigned short)(((unsigned long)(&gBufADC)) << 1) & 0xFFFFu;


	// DMA̓]TCY
	DMACEN0=DMA_BUF_SIZE*2;
	DMACFN0=1;

	//CfbNX͕sgp
    DMACSFI0 = 0x0000;	// channel source frame index    
    DMACSEI0 = 0x0000;    // channel source element index
    DMACSAC0 = 0x0000;    // channel source address counter
    DMACDAC0 = 0x0000;    // channel destination address counter
	DMACDEI0 = 0;  	  // channel destination element index
    DMACDFI0 = 0;    	// channel destination frame index


	/* DMA1SPȊMpɏBSPȊMSPIANZXn߂
	@@gKƂėpĂAMf[^̂̂̓_~[*/

	/*DMA1 McBSP0_xmt from DARAM*/
	DMACSDP1 = 0x0606;
			// 0000 0110 0000 0110b
			// 00~~ ~~~~ ~~~~ ~~~~	(DSTBEN)
			// ~~0~ ~~~~ ~~~~ ~~~~	(DSTPACK)
			// ~~~0 011~ ~~~~ ~~~~	(DST)=>peripheral
			// ~~~~ ~~~0 0~~~ ~~~~	(SRCBEN)
			// ~~~~ ~~~~ ~0~~ ~~~~	(SRCPACK)
			// ~~~~ ~~~~ ~~00 01~~	(SRC)=>DARAM
			// ~~~~ ~~~~ ~~~~ ~~10	(DATATYPE)32bit
	
	DMACCR1= 0x0312;
			// 0000 0011 0001 0010b
			// 00~~ ~~~~ ~~~~ ~~~~	(DSTAMODE)constant
			// ~~00 ~~~~ ~~~~ ~~~~	(SRCAMODE)constant
			// ~~~~ 0~~~ ~~~~ ~~~~	(ENDPROG)
			// ~~~~ ~0~~ ~~~~ ~~~~	(WP)
			// ~~~~ ~~1~ ~~~~ ~~~~	(REPEAT)
			// ~~~~ ~~~1 ~~~~ ~~~~	(AUTOINIT)
			// ~~~~ ~~~~ 0~~~ ~~~~	(EN)
			// ~~~~ ~~~~ ~0~~ ~~~~	(PRIO)
			// ~~~~ ~~~~ ~~0~ ~~~~	(FS)
			// ~~~~ ~~~~ ~~~1 0010	(SYNC)mcbsp1 xmt event
	
	DMACICR1= 0x0000;
			// 0000 0000 0000 0000b
			// ~~~~ ~~~0 ~~~~ ~~~~	Reserved (always write 0)
			// ~~~~ ~~~~ 0~~~ ~~~~	(AERRIE)
			// ~~~~ ~~~~ ~~0~ ~~~~	(BLOCKIE)
			// ~~~~ ~~~~ ~~~0 ~~~~	(LASTIE)
			// ~~~~ ~~~~ ~~~~ 0~~~	(FRAMEIE)
			// ~~~~ ~~~~ ~~~~ ~0~~	(HALFIE)
			// ~~~~ ~~~~ ~~~~ ~~0~	(DROPIE)
			// ~~~~ ~~~~ ~~~~ ~~~0	(TIMEOUTIE)

    DMACDSA1U = (unsigned short)(((unsigned long)(DXR21_ADDR)) >> 15) & 0xFFFFu;
    DMACDSA1L = (unsigned short)(((unsigned long)(DXR21_ADDR)) << 1) & 0xFFFFu;
    DMACSSA1U = (unsigned short)(((unsigned long)(&DummySpiXmtData)) >> 15) & 0xFFFFu;
    DMACSSA1L = (unsigned short)(((unsigned long)(&DummySpiXmtData)) << 1) & 0xFFFFu;


	// element number and frame number
	DMACEN1=DMA_BUF_SIZE*2;
	DMACFN1=1;

    DMACSFI1 = 0x0000;	// channel source frame index    
    DMACSEI1 = 0x0000;    // channel source element index
    DMACSAC1 = 0x0000;    // channel source address counter
    DMACDAC1 = 0x0000;    // channel destination address counter
	DMACDEI1 = 0;  	  // channel destination element index
    DMACDFI1 = 0;    	// channel destination frame index


	/*enable DMA*/
	DMACCR0 |= 0x80;
	DMACCR1 |= 0x80;

	asm(" RPT #10\n NOP\n ");
			
		    
}


/*---------------------------------------------------------
 * interrupt service routins
 *---------------------------------------------------------*/
/* DMA0̊荞ݏ */
/* DMA1̊荞ݏ͂Ȃ*/
interrupt void dma0int(void)
{
	volatile int read_stat;
	
	/*DMACSR is auto-cleared when be read*/
	read_stat=DMACSR0;
	
	if((read_stat &0x0004)==0x0004){
		gPointerBufADC=FIRST_HALF;
	}
	else if((read_stat&0x0008)==0x0008){
		gPointerBufADC=SECOND_HALF;
	}


}


