/*
 * Use CCS to build the COFF file ( .out ) by opening the
 * CCS project file ( .pjt ) and selecting Debug -> Build.
 * Afterwards, open a DOS window in the same directory and type:
 *
 *     > hex55 post_ahex.cmd
 *
 * to produce the ASCII Hex file ( .hex ) used for programming.
 * Use the FlashBurn application to program the Flash.
 *
 * For more help and options type:
 *
 *     > hex55 -h
 */

Debug\dspusb.out           /* Input File: COFF file format (.out) */
-a                          /* Output Format: ASCII Hex format (.hex) */
-boot                       /* Enable boot table generation */
-map dspusb_ahex.map          /* Name hex utility map file */
-o dspusb_asm.hex                 /* Output File: ASCII Hex file (.hex) */
-parallel16                 /* Generate output for a 16-bit wide Flash device */
-v5510:2                    /* Set processor type */

ROMS
{
    PAGE 0 : ROM : o=0x400000, l=0x200000
}
