//******************************************************************************
//       CMDPACK.H
//       USB R}hpPbg`
//******************************************************************************
#ifndef	_CMDPACK_H
#define	_CMDPACK_H

//******************************************************************************
//       CMDPACK constants
//******************************************************************************
#define	SIGNATURE	0x44425355	// 'USBD'

//**** Usb Command codes ****
#define	USBDCMD_NOP			0
#define	USBDCMD_STATUS			1
#define	USBDCMD_READ_MEMORY		2
#define	USBDCMD_WRITE_MEMORY		3
#define	USBDCMD_RUN			4
#define	USBDCMD_READ_BYTE		5
#define	USBDCMD_WRITE_BYTE		6
#define	USBDCMD_SYNC			7
#define	USBDCMD_PROGRAM			8

//******************************************************************************
//      CMDPACK structures
//******************************************************************************
#ifdef	WINNT
#pragma pack(push)
#pragma pack(1)
#define	__ATTR
#else
//#define	__ATTR	__attribute__ ((packed))
#define	__ATTR
#endif
typedef	struct	_USBCOMMAND	{
	ULONG	dwSignature;
	USHORT	bCommand;
	USHORT	bValue;
	ULONG	dwAddress;
	ULONG	dwLength;
}	__ATTR	USBCOMMAND,*PUSBCOMMAND;

typedef	struct	_USBRESPONSE	{
	ULONG	dwSignature;
	ULONG	dwStatus;
	ULONG	dwError;
	ULONG	dwReserved;
}	USBRESPONSE,*PUSBRESPONSE;



#ifdef	WINNT
#pragma pack(pop)
#endif

#endif
