/******************************************************************************
*-----------------------------------------------------------------------------
*  pll_init.c
*
******************************************************************************/

#include "c55x_regs.h"

void pll_init(){

	//------------------------------
	// Initialize PLL
	//------------------------------

	//12MHz clock is provided for DSK5509
	//12MHz x 16 = 192MHz
	// 12MHzĂDSK{[hDSP16{ɒ{
	CLKMD =  0x0810;
			// 0000 1000 0001 0000b
			// 0~~~ ~~~~ ~~~~ ~~~~	(rsvd)
			// ~0~~ ~~~~ ~~~~ ~~~~	(IAI)
			// ~~0~ ~~~~ ~~~~ ~~~~	(IOB)1:when break lock ,re-locking
			// ~~~0 ~~~~ ~~~~ ~~~~	(rsvd)
			// ~~~~ 1000 0~~~ ~~~~	(PLL MULTI) * 16
			// ~~~~ ~~~~ ~00~ ~~~~	(PLL DIV)00:no divide
			// ~~~~ ~~~~ ~~~1 ~~~~	(PLL enable)
			// ~~~~ ~~~~ ~~~~ 00~~	(BYPASS DIV)0:no divide
			// ~~~~ ~~~~ ~~~~ ~~0~	(BREAKLN)read only
			// ~~~~ ~~~~ ~~~~ ~~~0	(LOCK)read only,
	// PLLbN܂ő҂  
	while ((CLKMD & 0x0001) == 0) {}

	//DSPɂ͓NbNOCLKOUTsɏo͂邱Ƃł邪A
	//ł1/4{48MHzOo͂ƂĂ
	SYSR=0x0002;
			// 0000 1000 0001 0000b
			// ~~~~ ~~~~ ~~~~ ~010	(CLKDIV)CLKOUT is divided by 4


}


